<?php

namespace AppBundle\Repository;

use AppBundle\Entity\Task\Task as Task;

/**
 * ImageRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class TaskRepository extends \Doctrine\ORM\EntityRepository
{
    public function queryAll()
    {
        $qb = $this->createQueryBuilder('x');
        $qb->addOrderBy('x.date', 'ASC');
        $qb->addOrderBy('x.status', 'ASC');
        return $qb;
    }

    public function findTasks($filters, $isCompact)
    {
        if($isCompact) {
            $qb = $this->createQueryBuilder('t')
                ->leftJoin('t.group', 'g')
                ->andWhere('t.group IS NOT NULL')
                ->orderBy('g.title', 'ASC')
                ->addOrderBy('t.date', 'ASC')
                ->addOrderBy('t.status', 'ASC');
        } else {
            $qb = $this->createQueryBuilder('t')
                ->andWhere('t.group IS NOT NULL')
                ->addOrderBy('t.date', 'ASC')
                ->addOrderBy('t.status', 'ASC');
        }
        $qb->andWhere('t.status != :status OR (t.status = :status AND t.date >= :date)')
            ->setParameter('status', Task::STATUS_DONE)
            ->setParameter('date', new \DateTime());

        if (isset($filters['label'])){
            $qb->andWhere('t.title like :label')
                ->setParameter('label', '%'.$filters['label'].'%');
        }

        if (isset($filters['group'])){
            $qb->andWhere('t.group = :group')
                ->setParameter('group', $filters['group']);
        }

        if (isset($filters['status'])){
            $qb->andWhere($qb->expr()->in('t.status', $filters['status']));
        }


        return $qb;
    }
}
